diff --git a/lib/app/modules/petugas_desa/views/riwayat_stok_view.dart b/lib/app/modules/petugas_desa/views/riwayat_stok_view.dart
index 6dd26b5..1a524a3 100644
--- a/lib/app/modules/petugas_desa/views/riwayat_stok_view.dart
+++ b/lib/app/modules/petugas_desa/views/riwayat_stok_view.dart
@@ -247,148 +435,324 @@ class RiwayatStokView extends GetView<RiwayatStokController> {
         riwayat.stokBantuan != null ? riwayat.stokBantuan!['satuan'] ?? '' : '';
     final sumberLabels = {
       'penitipan': 'Penitipan',
-      'penyaluran': 'Penyaluran',
+      'penerimaan': 'Penerimaan',
       'manual': 'Manual',
     };
     final sumberLabel = sumberLabels[riwayat.sumber] ?? 'Tidak diketahui';
+    final sumberIcons = {
+      'penitipan': Icons.inventory,
+      'penerimaan': Icons.local_shipping,
+      'manual': Icons.edit,
+    };
+    final sumberIcon = sumberIcons[riwayat.sumber] ?? Icons.help_outline;
+    final sumberColors = {
+      'penitipan': Colors.blue,
+      'penerimaan': Colors.purple,
+      'manual': Colors.orange,
+    };
+    final sumberColor = sumberColors[riwayat.sumber] ?? Colors.grey;
 
-    return Card(
-      margin: const EdgeInsets.only(bottom: 12),
-      elevation: 2,
-      child: Padding(
-        padding: const EdgeInsets.all(16.0),
-        child: Column(
-          crossAxisAlignment: CrossAxisAlignment.start,
-          children: [
-            // Header: Jumlah dan waktu
-            Row(
-              children: [
-                // Icon & Jumlah
-                Container(
-                  padding: const EdgeInsets.symmetric(
-                    horizontal: 8,
-                    vertical: 4,
-                  ),
-                  decoration: BoxDecoration(
-                    color: isPenambahan ? Colors.green[100] : Colors.red[100],
-                    borderRadius: BorderRadius.circular(16),
-                  ),
-                  child: Row(
-                    mainAxisSize: MainAxisSize.min,
-                    children: [
-                      Icon(
-                        isPenambahan ? Icons.add : Icons.remove,
-                        color: isPenambahan ? Colors.green : Colors.red,
-                        size: 14,
-                      ),
-                      const SizedBox(width: 4),
-                      Text(
-                        '${riwayat.jumlah?.toStringAsFixed(0) ?? '0'} $stokBantuanSatuan',
-                        style: TextStyle(
-                          fontWeight: FontWeight.bold,
-                          color: isPenambahan ? Colors.green : Colors.red,
-                        ),
-                      ),
-                    ],
+    // Cek apakah memiliki id_referensi dan bukan dari sumber manual
+    final bool hasSumberReferensi = riwayat.idReferensi != null &&
+        riwayat.sumber != 'manual' &&
+        riwayat.idReferensi!.isNotEmpty;
+
+    return Container(
+      margin: const EdgeInsets.only(bottom: 16),
+      decoration: BoxDecoration(
+        color: Colors.white,
+        borderRadius: BorderRadius.circular(12),
+        boxShadow: [
+          BoxShadow(
+            color: Colors.black.withOpacity(0.05),
+            blurRadius: 8,
+            spreadRadius: 0,
+            offset: const Offset(0, 2),
+          ),
+        ],
+      ),
+      child: Material(
+        color: Colors.transparent,
+        borderRadius: BorderRadius.circular(12),
+        child: InkWell(
+          borderRadius: BorderRadius.circular(12),
+          onTap: hasSumberReferensi
+              ? () => _showReferensiDetailDialog(context, riwayat)
+              : null,
+          child: Column(
+            children: [
+              // Header dengan warna sesuai jenis perubahan
+              Container(
+                padding:
+                    const EdgeInsets.symmetric(horizontal: 16, vertical: 10),
+                decoration: BoxDecoration(
+                  color:
+                      isPenambahan ? Colors.green.shade50 : Colors.red.shade50,
+                  borderRadius: const BorderRadius.only(
+                    topLeft: Radius.circular(12),
+                    topRight: Radius.circular(12),
                   ),
                 ),
-                const Spacer(),
-                // Sumber
-                Container(
-                  padding: const EdgeInsets.symmetric(
-                    horizontal: 8,
-                    vertical: 4,
-                  ),
-                  decoration: BoxDecoration(
-                    color: Colors.grey[200],
-                    borderRadius: BorderRadius.circular(16),
-                  ),
-                  child: Text(
-                    sumberLabel,
-                    style: TextStyle(
-                      color: Colors.grey[700],
-                      fontSize: 12,
-                    ),
-                  ),
-                ),
-                const SizedBox(width: 8),
-                // Tanggal
-                Text(
-                  riwayat.createdAt != null
-                      ? DateTimeHelper.formatDateTime(riwayat.createdAt!)
-                      : '-',
-                  style: TextStyle(
-                    color: Colors.grey[600],
-                    fontSize: 12,
-                  ),
-                ),
-              ],
-            ),
-            const SizedBox(height: 12),
-
-            // Nama bantuan
-            Text(
-              stokBantuanNama,
-              style: Theme.of(context).textTheme.titleMedium?.copyWith(
-                    fontWeight: FontWeight.bold,
-                  ),
-            ),
-
-            // Alasan jika ada
-            if (riwayat.alasan != null && riwayat.alasan!.isNotEmpty) ...[
-              const SizedBox(height: 8),
-              Text(
-                'Alasan: ${riwayat.alasan}',
-                style: Theme.of(context).textTheme.bodyMedium,
-              ),
-            ],
-
-            // Foto bukti jika ada
-            if (riwayat.fotoBukti != null && riwayat.fotoBukti!.isNotEmpty) ...[
-              const SizedBox(height: 8),
-              InkWell(
-                onTap: () => _showImageDialog(context, riwayat.fotoBukti!),
                 child: Row(
                   children: [
-                    const Icon(
-                      Icons.photo,
-                      color: Colors.blue,
-                      size: 20,
+                    // Status dan jumlah
+                    Container(
+                      padding: const EdgeInsets.symmetric(
+                        horizontal: 8,
+                        vertical: 4,
+                      ),
+                      decoration: BoxDecoration(
+                        color: isPenambahan
+                            ? Colors.green.withOpacity(0.15)
+                            : Colors.red.withOpacity(0.15),
+                        borderRadius: BorderRadius.circular(16),
+                      ),
+                      child: Row(
+                        mainAxisSize: MainAxisSize.min,
+                        children: [
+                          Icon(
+                            isPenambahan ? Icons.add : Icons.remove,
+                            color: isPenambahan ? Colors.green : Colors.red,
+                            size: 16,
+                          ),
+                          const SizedBox(width: 4),
+                          Text(
+                            '${riwayat.jumlah?.toStringAsFixed(0) ?? '0'} $stokBantuanSatuan',
+                            style: TextStyle(
+                              fontWeight: FontWeight.bold,
+                              color: isPenambahan ? Colors.green : Colors.red,
+                            ),
+                          ),
+                        ],
+                      ),
                     ),
-                    const SizedBox(width: 4),
-                    Text(
-                      'Lihat Bukti',
-                      style: TextStyle(
-                        color: Colors.blue,
+                    const Spacer(),
+                    // Sumber
+                    Container(
+                      padding: const EdgeInsets.symmetric(
+                        horizontal: 8,
+                        vertical: 4,
+                      ),
+                      decoration: BoxDecoration(
+                        color: sumberColor.withOpacity(0.15),
+                        borderRadius: BorderRadius.circular(16),
+                      ),
+                      child: Row(
+                        mainAxisSize: MainAxisSize.min,
+                        children: [
+                          Icon(
+                            sumberIcon,
+                            size: 14,
+                            color: sumberColor,
+                          ),
+                          const SizedBox(width: 4),
+                          Text(
+                            sumberLabel,
+                            style: TextStyle(
+                              color: sumberColor,
+                              fontSize: 12,
+                              fontWeight: FontWeight.w500,
+                            ),
+                          ),
+                        ],
                       ),
                     ),
                   ],
                 ),
               ),
-            ],
 
-            // Petugas
-            if (riwayat.createdBy != null) ...[
-              const SizedBox(height: 12),
-              Row(
-                children: [
-                  const Icon(
-                    Icons.person,
-                    size: 16,
-                    color: Colors.grey,
-                  ),
-                  const SizedBox(width: 4),
-                  Text(
-                    'Oleh: ${riwayat.createdBy!['nama_lengkap'] ?? 'Tidak diketahui'}',
-                    style: TextStyle(
-                      color: Colors.grey[600],
-                      fontSize: 12,
+              // Konten
+              Padding(
+                padding: const EdgeInsets.all(16.0),
+                child: Column(
+                  crossAxisAlignment: CrossAxisAlignment.start,
+                  children: [
+                    // Nama bantuan
+                    Row(
+                      children: [
+                        Container(
+                          padding: const EdgeInsets.all(8),
+                          decoration: BoxDecoration(
+                            color: AppTheme.primaryColor.withOpacity(0.1),
+                            shape: BoxShape.circle,
+                          ),
+                          child: Icon(
+                            Icons.category,
+                            color: AppTheme.primaryColor,
+                            size: 20,
+                          ),
+                        ),
+                        const SizedBox(width: 12),
+                        Expanded(
+                          child: Column(
+                            crossAxisAlignment: CrossAxisAlignment.start,
+                            children: [
+                              Text(
+                                stokBantuanNama,
+                                style: const TextStyle(
+                                  fontWeight: FontWeight.bold,
+                                  fontSize: 16,
+                                ),
+                              ),
+                              const SizedBox(height: 4),
+                              Text(
+                                riwayat.createdAt != null
+                                    ? DateTimeHelper.formatDateTime(
+                                        riwayat.createdAt!)
+                                    : '-',
+                                style: TextStyle(
+                                  color: Colors.grey[600],
+                                  fontSize: 12,
+                                ),
+                              ),
+                            ],
+                          ),
+                        ),
+                      ],
                     ),
-                  ),
-                ],
+
+                    // Alasan jika ada
+                    if (riwayat.alasan != null &&
+                        riwayat.alasan!.isNotEmpty) ...[
+                      Padding(
+                        padding: const EdgeInsets.only(left: 44),
+                        child: Column(
+                          crossAxisAlignment: CrossAxisAlignment.start,
+                          children: [
+                            const SizedBox(height: 12),
+                            Row(
+                              crossAxisAlignment: CrossAxisAlignment.start,
+                              children: [
+                                Icon(
+                                  Icons.description_outlined,
+                                  size: 16,
+                                  color: Colors.grey[600],
+                                ),
+                                const SizedBox(width: 8),
+                                Expanded(
+                                  child: Text(
+                                    'Alasan: ${riwayat.alasan}',
+                                    style: TextStyle(
+                                      color: Colors.grey[700],
+                                    ),
+                                  ),
+                                ),
+                              ],
+                            ),
+                          ],
+                        ),
+                      ),
+                    ],
+
+                    // Foto bukti jika ada
+                    if (riwayat.fotoBukti != null &&
+                        riwayat.fotoBukti!.isNotEmpty) ...[
+                      const SizedBox(height: 12),
+                      Padding(
+                        padding: const EdgeInsets.only(left: 44),
+                        child: InkWell(
+                          onTap: () =>
+                              _showImageDialog(context, riwayat.fotoBukti!),
+                          child: Container(
+                            decoration: BoxDecoration(
+                              color: Colors.blue.withOpacity(0.1),
+                              borderRadius: BorderRadius.circular(8),
+                            ),
+                            padding: const EdgeInsets.symmetric(
+                              horizontal: 10,
+                              vertical: 6,
+                            ),
+                            child: Row(
+                              mainAxisSize: MainAxisSize.min,
+                              children: [
+                                const Icon(
+                                  Icons.photo,
+                                  color: Colors.blue,
+                                  size: 18,
+                                ),
+                                const SizedBox(width: 6),
+                                const Text(
+                                  'Lihat Bukti',
+                                  style: TextStyle(
+                                    color: Colors.blue,
+                                    fontWeight: FontWeight.w500,
+                                  ),
+                                ),
+                              ],
+                            ),
+                          ),
+                        ),
+                      ),
+                    ],
+
+                    // Info referensi jika ada
+                    if (hasSumberReferensi) ...[
+                      const SizedBox(height: 12),
+                      Padding(
+                        padding: const EdgeInsets.only(left: 44),
+                        child: Container(
+                          decoration: BoxDecoration(
+                            color: sumberColor.withOpacity(0.1),
+                            borderRadius: BorderRadius.circular(8),
+                          ),
+                          padding: const EdgeInsets.symmetric(
+                            horizontal: 10,
+                            vertical: 6,
+                          ),
+                          child: Row(
+                            mainAxisSize: MainAxisSize.min,
+                            children: [
+                              Icon(
+                                riwayat.sumber == 'penitipan'
+                                    ? Icons.inventory
+                                    : Icons.local_shipping,
+                                size: 18,
+                                color: sumberColor,
+                              ),
+                              const SizedBox(width: 6),
+                              Text(
+                                'Lihat detail ${riwayat.sumber}',
+                                style: TextStyle(
+                                  color: sumberColor,
+                                  fontWeight: FontWeight.w500,
+                                ),
+                              ),
+                            ],
+                          ),
+                        ),
+                      ),
+                    ],
+
+                    // Petugas
+                    if (riwayat.createdBy != null) ...[
+                      const Divider(height: 24),
+                      Row(
+                        children: [
+                          CircleAvatar(
+                            radius: 14,
+                            backgroundColor: Colors.grey[200],
+                            child: Icon(
+                              Icons.person,
+                              size: 18,
+                              color: Colors.grey[700],
+                            ),
+                          ),
+                          const SizedBox(width: 8),
+                          Text(
+                            'Oleh: ${riwayat.createdBy!['nama_lengkap'] ?? 'Tidak diketahui'}',
+                            style: TextStyle(
+                              color: Colors.grey[700],
+                              fontSize: 13,
+                            ),
+                          ),
+                        ],
+                      ),
+                    ],
+                  ],
+                ),
               ),
             ],
-          ],
+          ),
         ),
       ),
     );
@@ -400,37 +764,82 @@ class RiwayatStokView extends GetView<RiwayatStokController> {
       builder: (BuildContext context) {
         return Dialog(
           insetPadding: const EdgeInsets.all(16),
+          shape: RoundedRectangleBorder(
+            borderRadius: BorderRadius.circular(16),
+          ),
           child: Column(
             mainAxisSize: MainAxisSize.min,
             children: [
               AppBar(
                 leading: IconButton(
-                  icon: const Icon(Icons.close),
+                  icon: const Icon(
+                    Icons.close,
+                    color: Colors.white,
+                  ),
                   onPressed: () => Navigator.of(context).pop(),
                 ),
-                title: const Text('Bukti Foto'),
+                title: const Text(
+                  'Bukti Foto',
+                  style: TextStyle(
+                    color: Colors.white,
+                    fontWeight: FontWeight.bold,
+                  ),
+                ),
                 elevation: 0,
                 backgroundColor: AppTheme.primaryColor,
+                shape: const RoundedRectangleBorder(
+                  borderRadius: BorderRadius.only(
+                    topLeft: Radius.circular(16),
+                    topRight: Radius.circular(16),
+                  ),
+                ),
               ),
-              InteractiveViewer(
-                panEnabled: true,
-                boundaryMargin: const EdgeInsets.all(16),
-                minScale: 0.5,
-                maxScale: 4,
-                child: CachedNetworkImage(
-                  imageUrl: imageUrl,
-                  placeholder: (context, url) => const Center(
-                    child: CircularProgressIndicator(),
+              SizedBox(
+                height: MediaQuery.of(context).size.height * 0.5,
+                child: InteractiveViewer(
+                  panEnabled: true,
+                  boundaryMargin: const EdgeInsets.all(16),
+                  minScale: 0.5,
+                  maxScale: 4,
+                  child: CachedNetworkImage(
+                    imageUrl: imageUrl,
+                    placeholder: (context, url) => const Center(
+                      child: CircularProgressIndicator(),
+                    ),
+                    errorWidget: (context, url, error) => Column(
+                      mainAxisAlignment: MainAxisAlignment.center,
+                      children: [
+                        const Icon(Icons.error, color: Colors.red, size: 48),
+                        const SizedBox(height: 16),
+                        Padding(
+                          padding: const EdgeInsets.all(16.0),
+                          child: Text(
+                            'Gagal memuat gambar: $error',
+                            textAlign: TextAlign.center,
+                            style: const TextStyle(color: Colors.red),
+                          ),
+                        ),
+                      ],
+                    ),
+                    fit: BoxFit.contain,
                   ),
-                  errorWidget: (context, url, error) => Column(
-                    mainAxisAlignment: MainAxisAlignment.center,
-                    children: [
-                      const Icon(Icons.error),
-                      const SizedBox(height: 8),
-                      Text('Gagal memuat gambar: $error'),
-                    ],
-                  ),
-                  fit: BoxFit.contain,
+                ),
+              ),
+              Padding(
+                padding: const EdgeInsets.all(16.0),
+                child: Row(
+                  mainAxisAlignment: MainAxisAlignment.center,
+                  children: [
+                    const Icon(Icons.zoom_in, size: 20, color: Colors.grey),
+                    const SizedBox(width: 8),
+                    Text(
+                      'Cubit untuk memperbesar/memperkecil',
+                      style: TextStyle(
+                        color: Colors.grey[600],
+                        fontSize: 14,
+                      ),
+                    ),
+                  ],
                 ),
               ),
             ],
